ACHTUNG!

This is my personal set of ports for KISS, a POSIX(ish) meta distribution of
*NIX. These packages currently assume a Linux-based system, but support for
*BSD will likely arrive in the future. Please report any bugs to me via
email; thanks.

The overall goal of these packages is to provide a set of clean, mechanically
simple, stable tools that can be used to build your own system. Following
stability is the concern of security, and then performance.

Expect patches for many - if not most - packages, in the future.

The mbase directory contains symlinks to packages that I install as my core
userspace.

The banished directory contains software that has been isolated for whatever
reason. May or may not include a "JUSTIFICATION" file to remind myself in the
future.

Note that not all of the packages in this repo are written by me; some are
forked from Core and Community. This is purely a matter of convenience.

All packages under mbase have been tested and build on the Haswell
microarchitecture using the following CFLAGS (assuming GCC):

   -pipe
      Compile in memory

   -w
      Suppress errors

   -D_FORTIFY_SOURCE=1
      Perform lightweight tests to catch overflows and etc

   -O2
      Standard level of optimization

   -march=native
      Compile for the current micro-arch

   -fno-asynchronous-unwind-tables
      Do not include asynchronous unwind tables. Reduces binary size

   -momit-leaf-frame-pointer
      Leave out unneeded pointers

   -ftree-loop-vectorize
      Vectorize trees (unsure of the implications, but doesn't appear to cause
      breakage; will investigate further)

   -fstack-protector-strong
      Sacrifice a fair amount of performance in order to protect from stack
      smashing

   --param ssp-buffer-size=4
      Increase the number of functions under the stack protector

   -fstack-clash-protection
      Protect from stack clashing. Will investigate further

   -fPIE
      Generate position-independent executables

   -fPIC
      Generate position-independent code

   -Wl,--hash-style=gnu -Wl,-pie
      Linker arguments

A new subdir, bin, containing binaries built with the above CFLAGS (sans native)
will be added in the future. I, however, encourage you to build from source if
possible.

________________________________________________________________________________

|/                                                         https://k1sslinux.org
|\ISS                                 https://git.sdf.org/midfavila/kiss-mfavila
________________________________________________________________________________

(Un)Official Repositories

________________________________________________________________________________

The unofficial repositories for KISS Linux maintained by Mid Favila.
Included in my repo is a snapshot of the community and musl core, xorg, and
extra repos as of 2021/7/9, modified to replace the utterly garbage packages
that some members had contributed (in blatant violation of guidelines, too!).

These were forked due to upstream's insistence on switching from LibreSSL to
OpenSSL, and from X11 to Wayland; the former due to Python, and the latter,
I'm not quite sure of. Regardless, I dislike these changes.

Over time, packages that I'm not willing to maintain will be moved to
mid-graveyard; after a few months, they'll be deleted.

Any programs that require Python as a build-time dependency will have their
scripts rewritten in Common Lisp, or they will be removed. This will happen
ASAP.

I will also be removing packages that I just flat out don't like. If you want
them yourself, then copy them from an old git push. Software that will be
removed and never added includes, but is not limited to, the following;

   -systemd or any of its ilk
   -OpenSSL or programs that explicitly depend on it
   -Programs that require a version of Python newer than 3.9
   -Programs written with or requiring Rust tooling
   -Programs written primarily by or for corporations, such as BTRFS utilities
      (This applies triply to FAGMAN; Facebook, Apple, Google, Microsoft,
      Amazon, and Netflix. I also will not tolerate software related to Tencent
      or similar organizations)

NOTE THAT I AM NOT AFFILIATED WITH THE KISS LINUX ORGANIZATION IN ANY OFFICIAL
CAPACITY. THEY ARE NOT RESPONSIBLE FOR THESE PACKAGES. DO NOT SUBMIT REPORTS IN
#KISSLINUX ON LIBERA.CHAT IF THESE BREAK; EMAIL ME.

ALSO NOTE THAT THESE PACKAGES ARE CURRENTLY BEING REWRITTEN AND ARE NOT LIKELY
TO BE IN A USABLE STATE. I WILL NOT ACCEPT BUG REPORTS RELATING TO COMMUNITY
OR CORE, AND I WILL NOT ACCEPT REPORTS IF YOUR SYSTEM IS COMPILED WITH FLAGS
THAT ARE NOT INCLUDED ABOVE.

BEFORE SUBMITTING BUG REPORTS, READ ERIC S. RAYMOND'S "HOW TO ASK QUESTIONS THE
SMART WAY", AND SPEND SOME TIME STUDYING YOUR LOGS. I HAVE NO QUALMS HELPING
USERS, IF THEY TRY TO HELP THEMSELVES.

BE SURE TO INCLUDE THE FOLLOWING:
   -PACKAGE BUILD LOG
   -SYSTEM DMESG
   -YOUR CFLAGS
   -GCC VERSION (CLANG UNSUPPORTED)
   -X11 LOGS (IF RELEVANT; WAYLAND UNSUPPORTED)
THANK YOU FOR YOUR COOPERATION.
